@inherits JonesComponentBase
@using Jones.AspNetCore.Utils
@using Jones.AspNetCore.TailwindCSS.FlowBite.Types

<div @attributes="@AdditionalAttributes" class="@Class" role="document" @ref="DialogElement">
    <!-- Modal content -->
    <div class="modal-content">
        @ChildContent
    </div>
</div>

@code {
    private ElementReference DialogElement { get; set; }
    
    private string? Class => CssBuilder.Default("modal-dialog")
        .AddClass("modal-dialog-centered", IsCentered)
        .AddClass($"modal-{Size?.GetDisplayName()}", Size != null)
        .AddClass("modal-dialog-scrollable", IsScrolling)
        .AddClassFromAttributes(AdditionalAttributes)
        .Build();

    [Parameter]
    public Size? Size { get; set; }

    /// <summary>
    /// 获得/设置 是否垂直居中
    /// </summary>
    [Parameter]
    public bool IsCentered { get; set; } = true;

    /// <summary>
    /// 获得/设置 是否弹窗正文超长时滚动
    /// </summary>
    [Parameter]
    public bool IsScrolling { get; set; }
    
    [Parameter]
    public RenderFragment? ChildContent { get; set; }
}